//=============================================================================
//  Visual Basic ɂ͂߂ẴASY(͐Y/Zp]_)
//  Rs[^摜(cGs/I[)
//=============================================================================

unit Affine;

interface

uses
    Windows, SysUtils, Graphics, Types, Math;

//-----------------------------------------------------------------------------
//  TPoint Double
type
    TPointEx = record X: Double; Y: Double; end;
    PPointEx = ^TPointEx;
    TPointExArray = array of TPointEx;
    TPointArray = array of TPoint;

//-----------------------------------------------------------------------------
//  \̏1
function PointEx(const AX, AY: Double): TPointEx;       overload;

//  \̏2
function PointEx(): TPointEx;                           overload;

//  \̏3
function PointEx(const Pt: TPointEx): TPointEx;         overload;

//  \̏4
function PointEx(const Pt: TPoint): TPointEx;           overload;

//-----------------------------------------------------------------------------
//  TPointƂ̑ݕϊ
function PointExToPoint(const Pt: TPointEx): TPoint;    overload;

//-----------------------------------------------------------------------------
//  ]
function InversePoint(const Pt: TPointEx): TPointEx;

//  ](ύX)
function InversePoint2(var Pt: TPointEx): TPointEx;

//  Z
function PlusPoint(const LeftPt, RightPt: TPointEx): TPointEx;

//  Z
function MinusPoint(const LeftPt, RightPt: TPointEx): TPointEx;

//-----------------------------------------------------------------------------
//  sړ
function Translate(const Pt: TPointEx; const X, Y: Double): TPointEx; overload;

//  sړ(ύX)
function Translate2(var Pt: TPointEx; const X, Y: Double): TPointEx; overload;

//  w肳ꂽ_S̉]ړ
function Rotate(const Pt, Center: TPointEx; const Radian: Double): TPointEx;

//  w肳ꂽ_S̉]ړ(ύX)
function Rotate2(var Pt: TPointEx; const Center: TPointEx; const Radian: Double): TPointEx;

//  _S̉]ړ
function RotateZ(const Pt: TPointEx; const Radian: Double): TPointEx;

//  _S̉]ړ(ύX)
function RotateZ2(var Pt: TPointEx; const Radian: Double): TPointEx;

//  w肳ꂽ_S̊gEk
function Magnify(const Pt, Center: TPointEx; const Rate: Double): TPointEx; overload;

//  w肳ꂽ_S̊gEk(ύX)
function Magnify2(var Pt: TPointEx; const Center: TPointEx; const Rate: Double): TPointEx; overload;

//  _S̊gEk
function MagnifyZ(const Pt: TPointEx; const Rate: Double): TPointEx;

//  _S̊gEk(ύX)
function MagnifyZ2(var Pt: TPointEx; const Rate: Double): TPointEx;

//-----------------------------------------------------------------------------
//  S_߂
function CenterPoint(const Pts: TPointExArray): TPointEx;

//  TRect _̔zɕϊ
procedure Rect2PointEx(const Rt: TRect; var Pts: TPointExArray);

//-----------------------------------------------------------------------------
//  _̔z`
procedure DrawPoints(Canvas: TCanvas; const Pts: TPointArray; const Fill: Boolean);

//=============================================================================
//  ]_\NX
//=============================================================================

type
    TRotatePoints = class
    private
        FCount: Integer;
        FOriginalEx: TPointExArray;
        FOriginal: TPointArray;
        FResultEx: TPointExArray;
        FResult: TPointArray;
        FCenter: TPointEx;
        FTranslateX: Double;
        FTranslateY: Double;
        FRadian: Double;
        FRate: Double;

        //  ]̒Sݒ肷
        procedure SetCenter(const Pt: TPoint);

        //  ]̒S擾
        function GetCenter(): TPoint;

    public
        //  RXgN^
        constructor Create();

        //  fXgN^
        destructor Destroy(); override;
    public
        //  _̔zNA
        procedure Clear();

        //  ]_̔zݒ肷
        procedure SetPoint(const Pts: TPointExArray); overload;

        //  ]_̔zݒ肷(TPoint)
        procedure SetPoint(const Pts: TPointArray); overload;

        //  ]_̔zݒ肷(TRect)
        procedure SetPoint(const Rt: TRect); overload;

        //  ]puxvŐݒ肷
        procedure SetDegree(const Degree: Double);

        //  _̔z̒S]̒Sɐݒ肷
        procedure SetCenterOfPts();

        //  vpeB
        property CenterEx: TPointEx read FCenter write FCenter;
        property Center: TPoint read GetCenter write SetCenter;
        property TranslateX: Double read FTranslateX write FTranslateX;
        property TranslateY: Double read FTranslateY write FTranslateY;
        property Radian: Double read FRadian write FRadian;
        property Rate: Double read FRate write FRate;
        property OriginalEx: TPointExArray read FOriginalEx;
        property Original: TPointArray read FOriginal;
        property ResultEx: TPointExArray read FResultEx;
        property Result: TPointArray read FResult;
    public
        //  ЂƂ̓_ϊs
        function Execute(const Pt: TPointEx): TPointEx; overload;

        //  ϊs
        procedure Execute(); overload;

        //  ϊO̓_``
        procedure DrawOriginal(Canvas: TCanvas; const Fill: Boolean);

        //  ϊ̓_̔z`
        procedure DrawResult(Canvas: TCanvas; const Fill: Boolean);
    end;

implementation

//=============================================================================
//  UTILITY
//=============================================================================

//-----------------------------------------------------------------------------
//  \̏1
function PointEx(const AX, AY: Double): TPointEx;
begin
    Result.X := AX;
    Result.Y := AY;
end;

//-----------------------------------------------------------------------------
//  \̏2
function PointEx(): TPointEx;
begin
    Result := PointEx(0, 0);
end;

//-----------------------------------------------------------------------------
//  \̏3
function PointEx(const Pt: TPointEx): TPointEx;
begin
    Result := PointEx(Pt.X, Pt.Y);
end;

//-----------------------------------------------------------------------------
//  \̏4
function PointEx(const Pt: TPoint): TPointEx;
begin
    Result := PointEx(Pt.X, Pt.Y);
end;

//-----------------------------------------------------------------------------
//  TPointƂ̑ݕϊ2
function PointExToPoint(const Pt: TPointEx): TPoint;
begin
    Result := Types.Point(Trunc(Pt.X), Trunc(Pt.Y));
end;

//-----------------------------------------------------------------------------
//  ]
function InversePoint(const Pt: TPointEx): TPointEx;
begin
    Result := PointEx(-Pt.X, -Pt.Y);
end;

//-----------------------------------------------------------------------------
//  ](ύX)
function InversePoint2(var Pt: TPointEx): TPointEx;
begin
    Pt := InversePoint(Pt);
    Result := Pt;
end;

//-----------------------------------------------------------------------------
//  Z
function PlusPoint(const LeftPt, RightPt: TPointEx): TPointEx;
begin
    Result := PointEx(LeftPt.X + RightPt.X, LeftPt.Y + RightPt.Y);
end;

//-----------------------------------------------------------------------------
//  Z
function MinusPoint(const LeftPt, RightPt: TPointEx): TPointEx;
begin
    Result := PlusPoint(LeftPt, InversePoint(RightPt));
end;

//-----------------------------------------------------------------------------
//  sړ
function Translate(const Pt: TPointEx; const X, Y: Double): TPointEx;
begin
    Result := PlusPoint(Pt, PointEx(X, Y));
end;

//-----------------------------------------------------------------------------
//  sړ(ύX)
function Translate2(var Pt: TPointEx; const X, Y: Double): TPointEx;
begin
    Pt := Translate(Pt, X, Y);
    Result := Pt;
end;

//-----------------------------------------------------------------------------
//  w肳ꂽ_S̉]ړ
function Rotate(const Pt, Center: TPointEx; const Radian: Double): TPointEx;
var
    Sin, Cos: Extended;
    Pt1: TPointEx;
begin
	Math.SinCos(Radian, Sin, Cos);
    Pt1 := MinusPoint(Pt, Center);
    Result.X := Pt1.X * Cos - Pt1.Y * Sin;
    Result.Y := Pt1.X * Sin + Pt1.Y * Cos;
    Result := PlusPoint(Result, Center);
end;

//-----------------------------------------------------------------------------
//  w肳ꂽ_S̉]ړ(ύX)
function Rotate2(var Pt: TPointEx; const Center: TPointEx; const Radian: Double): TPointEx;
begin
    Pt := Rotate(Pt, Center, Radian);
    Result := Pt;
end;

//-----------------------------------------------------------------------------
//  _S̉]ړ
function RotateZ(const Pt: TPointEx; const Radian: Double): TPointEx;
begin
    Result := Rotate(Pt, PointEx(), Radian);
end;

//-----------------------------------------------------------------------------
//  _S̉]ړ(ύX)
function RotateZ2(var Pt: TPointEx; const Radian: Double): TPointEx;
begin
    Pt := RotateZ(Pt, Radian);
    Result := Pt;
end;

//-----------------------------------------------------------------------------
//  w肳ꂽ_S̊gEk
function Magnify(const Pt, Center: TPointEx; const Rate: Double): TPointEx;
var
    Pt1: TPointEx;
begin
    Pt1 := MinusPoint(Pt, Center);
    Result := PointEx(Pt1.X * Rate, Pt1.Y * Rate);
    Result := PlusPoint(Result, Center);
end;

//-----------------------------------------------------------------------------
//  w肳ꂽ_S̊gEk(ύX)
function Magnify2(var Pt: TPointEx; const Center: TPointEx; const Rate: Double): TPointEx;
begin
    Pt := Magnify(Pt, Center, Rate);
    Result := Pt;
end;

//-----------------------------------------------------------------------------
//  _S̊gEk
function MagnifyZ(const Pt: TPointEx; const Rate: Double): TPointEx;
begin
    Result := Magnify(Pt, PointEx(), Rate);
end;

//-----------------------------------------------------------------------------
//  _S̊gEk(ύX)
function MagnifyZ2(var Pt: TPointEx; const Rate: Double): TPointEx;
begin
    Pt := MagnifyZ(Pt, Rate);
    Result := Pt;
end;

//-----------------------------------------------------------------------------
//  S_߂
function CenterPoint(const Pts: TPointExArray): TPointEx;
var
	i, Len: Integer;
	X, Y: array of Double;
begin
    Len := Length(Pts);
	SetLength(X, Len);
	SetLength(Y, Len);
    for i := 0 to Len - 1 do
    begin
		X[i] := Pts[i].X;
		Y[i] := Pts[i].Y;
    end;
    if (Len > 0) then
    begin
        Result := PointEx(Math.Mean(X), Math.Mean(Y));
    end
    else
    begin
        Result := PointEx();
    end;
end;

//-----------------------------------------------------------------------------
//  TRect _̔zɕϊ
procedure Rect2PointEx(const Rt: TRect; var Pts: TPointExArray);
begin
    SetLength(Pts, 4);
	Pts[0] := PointEx(Rt.Left, Rt.Top);
	Pts[1] := PointEx(Rt.Left, Rt.Bottom);
	Pts[2] := PointEx(Rt.Right, Rt.Bottom);
	Pts[3] := PointEx(Rt.Right, Rt.Top);
end;

//-----------------------------------------------------------------------------
//  _̔z`
procedure DrawPoints(Canvas: TCanvas; const Pts: TPointArray; const Fill: Boolean);
var
	i, Len: integer;
    Pts1: TPointArray;
	OldStyle: TBrushStyle;
begin
    //  擪_Ɩ_Ȃ
    Len := Length(Pts);
	SetLength(Pts1, Len + 1);
    for i := 0 to Len - 1 do Pts1[i] := Pts[i];
    Pts1[Len] := Pts1[0];

    //  `
    OldStyle := Canvas.Brush.Style;
    if (Fill) then
    begin
        Canvas.Brush.Style := bsSolid;
        Canvas.Polyline(Pts);
    end
    else
    begin
        Canvas.Brush.Style := bsClear;
        Canvas.Polygon(Pts);
    end;
    Canvas.Brush.Style := OldStyle;
end;

//=============================================================================
//  ]_\NX
//=============================================================================

//-----------------------------------------------------------------------------
//  ]̒Sݒ肷
procedure TRotatePoints.SetCenter(const Pt: TPoint);
begin
    FCenter := PointEx(Pt);
end;

//-----------------------------------------------------------------------------
//  ]̒S擾
function TRotatePoints.GetCenter(): TPoint;
begin
    Result := PointExToPoint(FCenter);
end;

//-----------------------------------------------------------------------------
//  RXgN^
constructor TRotatePoints.Create();
begin
    inherited;
    FCount := 0;
    FCenter := PointEx();
    FTranslateX := 0;
    FTranslateY := 0;
    FRadian := 0;
    FRate := 1;
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TRotatePoints.Destroy();
begin
    inherited;
end;

//-----------------------------------------------------------------------------
//  _̔zNA
procedure TRotatePoints.Clear();
begin
    //  o
    Create();

    //  z񏉊
    SetLength(FOriginalEx, 0);
    SetLength(FOriginal, 0);
    SetLength(FResultEx, 0);
    SetLength(FResult, 0);
end;

//-----------------------------------------------------------------------------
//  ]_̔zݒ肷
procedure TRotatePoints.SetPoint(const Pts: TPointExArray);
var
    i: Integer;
begin
    //  _̌
    FCount := Length(Pts);

    //  z̃TCY
    SetLength(FOriginalEx, FCount);
    SetLength(FOriginal, FCount);
    SetLength(FResultEx, FCount);
    SetLength(FResult, FCount);

    //  _Rs[
    for i := 0 to FCount - 1 do
    begin
        FOriginalEx[i] := Pts[i];
        FOriginal[i] := PointExToPoint(Pts[i]);
    end;
end;

//-----------------------------------------------------------------------------
//  ]_̔zݒ肷(TPoint)
procedure TRotatePoints.SetPoint(const Pts: TPointArray);
var
    i: Integer;
begin
    //  _̌
    FCount := Length(Pts);

    //  z̃TCY
    SetLength(FOriginalEx, FCount);
    SetLength(FOriginal, FCount);
    SetLength(FResultEx, FCount);
    SetLength(FResult, FCount);

    //  _Rs[
    for i := 0 to FCount - 1 do
    begin
        FOriginalEx[i] := PointEx(Pts[i]);
        FOriginal[i] := Pts[i];
    end;
end;

//-----------------------------------------------------------------------------
//  ]_̔zݒ肷(TRect)
procedure TRotatePoints.SetPoint(const Rt: TRect);
var
    Pts: TPointExArray;
begin
    Rect2PointEx(Rt, Pts);
    SetPoint(Pts);
end;

//-----------------------------------------------------------------------------
//  ]puxvŐݒ肷
procedure TRotatePoints.SetDegree(const Degree: Double);
begin
    FRadian := DegToRad(Degree);
end;

//-----------------------------------------------------------------------------
//  _̔z̒S]̒Sɐݒ肷
procedure TRotatePoints.SetCenterOfPts();
begin
    FCenter := CenterPoint(FOriginalEx);
end;

//-----------------------------------------------------------------------------
//  ЂƂ̓_ϊs
function TRotatePoints.Execute(const Pt: TPointEx): TPointEx;
begin
    Result := Pt;

    //  ]ړ
    Rotate2(Result, FCenter, FRadian);

    //  g
    Magnify2(Result, FCenter, FRate);

    //  sړ
    Translate2(Result, FTranslateX, FTranslateY);
end;

//-----------------------------------------------------------------------------
//  ϊs
procedure TRotatePoints.Execute();
var
    i: Integer;
    Pt: TPointEx;
begin
    for i := 0 to FCount - 1 do
    begin
        Pt := FOriginalEx[i];

        //  ϊ
        Pt := Execute(Pt);

        //  ێ
        FResultEx[i] := Pt;
        FResult[i]   := PointExToPoint(Pt);
    end;
end;

//-----------------------------------------------------------------------------
//  ϊO̓_``
procedure TRotatePoints.DrawOriginal(Canvas: TCanvas; const Fill: Boolean);
begin
    DrawPoints(Canvas, FOriginal, Fill);
end;

//-----------------------------------------------------------------------------
//  ϊ̓_̔z`
procedure TRotatePoints.DrawResult(Canvas: TCanvas; const Fill: Boolean);
begin
    DrawPoints(Canvas, FResult, Fill);
end;

end.
