unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, Affine;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    Label6: TLabel;
    TrackBar3: TTrackBar;
    Label7: TLabel;
    TrackBar4: TTrackBar;
    Label8: TLabel;
    PaintBox1: TPaintBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    PaintBox2: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
  private
    FBitmap: TBitmap;
    FSource: TBitmap;
    FRotater: TRotatePoints;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    Math;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  RXgN^
procedure TForm1.FormCreate(Sender: TObject);
var
    R: TRect;
var
    i: Integer;
    LogPalette: TMaxLogPalette;
begin
    //  _uobt@prbg}bv
    FBitmap := TBitmap.Create();
    FBitmap.Width := PaintBox1.Width;
    FBitmap.Height := PaintBox1.Height;
    FBitmap.PixelFormat := pf8bit;
    PaintBox1.ControlStyle := PaintBox1.ControlStyle + [csOpaque];

    //  O[XP[ɂ邽߂(?)pbg쐬
    with LogPalette do
    begin
        palNumEntries := 256;
        palVersion := $0300;
        for i := 0 to 255 do
        begin
            palPalEntry[i].peRed   := 255 - i;
            palPalEntry[i].peGreen := 255 - i;
            palPalEntry[i].peBlue  := 255 - i;
        end;
    end;
    FBitmap.Palette := CreatePalette(PLogPalette(@LogPalette)^);

    FSource := TBitmap.Create();
    FSource.Width := PaintBox2.Width;
    FSource.Height := PaintBox2.Height;
    PaintBox2.ControlStyle := PaintBox2.ControlStyle + [csOpaque];

    //  ]NX
    FRotater := TRotatePoints.Create();

    //  lp`ݒ
    R := PaintBox1.ClientRect;
    FRotater.SetPoint(R);

    //  ϊp[^ݒ
    FRotater.TranslateX := TrackBar1.Position;
    FRotater.TranslateY := TrackBar2.Position;
    FRotater.Radian := DegToRad(TrackBar3.Position);
    FRotater.Rate   := TrackBar4.Position / 10;

    //  p[^\
    Label9.Caption := IntToStr(TrackBar1.Position);
    Label10.Caption := IntToStr(TrackBar2.Position);
    Label11.Caption := IntToStr(TrackBar3.Position);
    Label12.Caption := FormatFloat('0.00', TrackBar4.Position / 10);
end;

//-----------------------------------------------------------------------------
//  fXgN^
procedure TForm1.FormDestroy(Sender: TObject);
begin
    FBitmap.Free();
    FRotater.Free();
end;

//-----------------------------------------------------------------------------
//  p[^ύX
procedure TForm1.TrackBar1Change(Sender: TObject);
var
    TrackBar: TTrackBar;
begin
    TrackBar := TTrackBar(Sender);

    //  sړ()
    if (TrackBar = TrackBar1) then
    begin
        FRotater.TranslateX := TrackBar.Position;
        Label9.Caption := IntToStr(TrackBar.Position);
    end
    //  sړ(c)
    else if (TrackBar = TrackBar2) then
    begin
        FRotater.TranslateY := TrackBar.Position;
        Label10.Caption := IntToStr(TrackBar.Position);
    end
    //  ]px
    else if (TrackBar = TrackBar3) then
    begin
        FRotater.Radian := DegToRad(TrackBar.Position);
        Label11.Caption := IntToStr(TrackBar.Position);
    end
    //  g嗦
    else if (TrackBar = TrackBar4) then
    begin
        FRotater.Rate   := TrackBar.Position / 10;
        Label12.Caption := FormatFloat('0.00', TrackBar.Position / 10);
    end;

    //  ĕ`
    PaintBox2.Repaint();
end;

//-----------------------------------------------------------------------------
//  `Cxg(摜)
procedure TForm1.PaintBox2Paint(Sender: TObject);
begin
    //  wihԂ
    FSource.Canvas.Draw(0, 0, Image1.Picture.Bitmap);

    //  ]̒Slp`̒SɎĂ
    FRotater.SetCenterOfPts();

    //  ]EsړEgks
    FRotater.Execute();

    //  ̎lp`Ԃŕ`
    FSource.Canvas.Pen.Color := clRed;
    FRotater.DrawResult(FSource.Canvas, False);
    FSource.Canvas.Pen.Color := clBlack;

    //  _uobt@ʂɓ]
    BitBlt(PaintBox2.Canvas.Handle, 0, 0, PaintBox2.Width, PaintBox2.Height,
            FSource.Canvas.Handle, 0, 0, SRCCOPY);

    //  o摜`
    PaintBox1.Repaint();
end;

//-----------------------------------------------------------------------------
//  `Cxg
procedure TForm1.PaintBox1Paint(Sender: TObject);
var
    x, y: Integer;
    h, w: Integer;
    r: TRect;
    PtEx: TPointEx;
    Pt: TPoint;
    DiffX, DiffY: Double;
    TL, TR, BL, BR: Byte;
    TValue, BValue: Double;
    Source: TBitmap;
    IsRight, IsBottom: Boolean;
begin
    //  wihԂ
    FBitmap.Canvas.FillRect(PaintBox1.ClientRect);

    //  RRC

    h := PaintBox1.Height;
    w := PaintBox1.Width;
    r := PaintBox2.ClientRect;
    Source := Image1.Picture.Bitmap;

    //  ̉摜̊e_̐F肷
    for y := 0 to h - 1 do
    begin
        for x := 0 to w - 1 do
        begin
            //  ̓_ϊ_vZ
            PtEx := FRotater.Execute(PointEx(x, y));

            //  iq_̓_
            Pt := PointExToPoint(PtEx);

            //  ۂ̊iq_ƕϊ_Ƃ̍߂
            DiffX := PtEx.X - Pt.X; 
            DiffY := PtEx.Y - Pt.Y;

            //  摜̒ɓĂꍇ̂ݏ
            if (PtInRect(r, Pt)) then
            begin
                //  _Ԃiq_̐Fo

                //  (͂܂Ɋiq_̂)
                TL := PByteArray(Source.ScanLine[Pt.y])[Pt.x];

                //  ̓_Eɓ_Ȃ
                if (Pt.X < Source.Width - 1) then
                begin
                    //  E̓_ɂ
                    TR := PByteArray(Source.ScanLine[Pt.y])[Pt.x + 1];
                    IsRight := False;
                end

                //  ȂȂ
                else
                begin
                    //  E̓_͍Ɉv
                    TR := TL;
                    IsRight := True;
                end;

                //  ̓_ɓ_Ȃ
                if (Pt.Y < Source.Height - 1) then
                begin
                    //  ̓_ɂ
                    BL := PByteArray(Source.ScanLine[Pt.y + 1])[Pt.x];
                    IsBottom := False;
                end

                //  ȂȂ
                else
                begin
                    //  ̓_͍Ɉv
                    BL := TL;
                    IsBottom := True;
                end;

                //  ̓_E[ł[łȂȂ
                if (not IsRight) and (not IsBottom) then
                begin
                    //  E̓_ɂ
                    BR := PByteArray(Source.ScanLine[Pt.y + 1])[Pt.x + 1];
                end

                //  ȊȌꍇ
                else
                begin
                    //  E̓_͍̓_Ɉv
                    BR := BL;
                end;

                //  TL(TopLeft) TR(TopRight) ̒Ԓl
                TValue := TL * (1 - DiffX) + TR * DiffX;

                //  TL(BottomLeft) TR(BottomRight) ̒Ԓl
                BValue := BL * (1 - DiffX) + BR * DiffX;

                //  ̒Ԓl𐶐_̒lƂ
                PByteArray(FBitmap.ScanLine[y])[x] := Round(255 - (TValue * (1 - DiffY) + BValue * DiffY));
            end;
        end;
    end;

    //  _uobt@ʂɓ]
    //FBitmap.SaveToFile(ChangeFileExt(ParamStr(0), '.bmp'));
    BitBlt(PaintBox1.Canvas.Handle, 0, 0, PaintBox1.Width, PaintBox1.Height,
            FBitmap.Canvas.Handle, 0, 0, SRCCOPY);
end;

end.
